# -*- ecoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv
import netsvc
import datetime
import time

class procurement(osv.osv):
    _inherit="procurement.order"

    def action_produce_assign_product(self, cr, uid, ids, context=None):
        """ Blocks the procurement being run for products with assembly bom
         @param self: The object pointer.
         @param ids: ids of the procurement order document
         @param context: standard dictionary
         @comment: Blocks the procurement to be run for products with assembly bom
         @return: returns either the Manufacturing order id or 0
        """
        procurement_obj = self.pool.get('procurement.order')
        bom_obj=self.pool.get('mrp.bom')
        sale_line_obj=self.pool.get('sale.order.line')
        res=[]
        for procure_record in procurement_obj.browse(cr,uid,ids,context=context):
            sale_line_ids=sale_line_obj.search(cr,uid,[('procurement_id','=',procure_record.id)],context=context)
            sale_line_id=sale_line_ids and sale_line_ids[0] or False
            if sale_line_id:
                line=sale_line_obj.browse(cr,uid,sale_line_id,context=context)
                if line.product_id:
                    bom_ids=bom_obj.search(cr,uid,[('product_id','=',line.product_id.id),('type','=','assembly')],context={})
                    bom_id=bom_ids and bom_ids[0] or False
                    if bom_id:
                        #1. print 'PROCUREMENT:"PROCUREMENT FOR THE PRODUCT:%s, Name:%s" HAS BEEN BLOCKED'%(line.product_id.id,line.product_id.name)
                        return 0
            return super(procurement, self).action_produce_assign_product( cr, uid, [procure_record.id], context=context)

procurement()

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:


