# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time

from report import report_sxw

class delivery_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context=None):
        super(delivery_report, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
#            'detail_list':context.get('detail_list', [])
            '_get_parent':self._get_parent,
            '_get_childs':self._get_childs
        })

    def _get_parent(self,pick_id):
        cr=self.cr
        uid=self.uid
        context=self.localcontext
        move_obj=self.pool.get('stock.move')
        move_ids=move_obj.search(cr,uid,[('picking_id','=',pick_id),("parent_bom_id","!=",False)])
        moves=move_obj.browse(cr,uid,move_ids,context=context)
        for move in moves:
            production=move.kit_id
            if production:
                product_qty=production.product_qty
                sale_id=move.sale_id.id

                parent_move_ids=move_obj.search(cr,uid,[("sale_id","=",sale_id),
                                                       ("product_qty","=",product_qty),
                                                       ("product_id","=",production.product_id.id)])
                parent_moves=move_obj.browse(cr,uid,parent_move_ids)
                print "parent_move_ids",parent_move_ids
#                return {'child_moves':moves,"parent_moves":parent_moves}
                return parent_moves
                break

    def _get_childs(self,pick_id):
        cr=self.cr
        uid=self.uid
        context=self.localcontext
        move_obj=self.pool.get('stock.move')
        move_ids=move_obj.search(cr,uid,[('picking_id','=',pick_id),("parent_bom_id","!=",False)])
        print move_ids,'====================move_ids================================'
        return move_obj.browse(cr,uid,move_ids,context=context)

report_sxw.report_sxw('report.delivery.bom', 'stock.picking', 'addons/assembly_bom/report/delivery_report.rml', parser=delivery_report, header=False)

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

