# -*- ecoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv
import netsvc
import datetime
import time
from tools.translate import _

class sale_order_line(osv.osv):
    _inherit = 'sale.order.line'
    def product_id_change(self, cr, uid, ids, pricelist, product, qty=0,
            uom=False, qty_uos=0, uos=False, name='', partner_id=False,
            lang=False, update_tax=True, date_order=False, packaging=False, fiscal_position=False, flag=False,partner_shipping_id=False, shop_id=False, context={}):
        
        ret=super(sale_order_line, self).product_id_change(cr, uid, ids, pricelist, product, qty=qty,uom=uom, qty_uos=qty_uos, uos=uos, name=name, partner_id=partner_id,lang=lang, update_tax=update_tax, date_order=date_order, packaging=packaging, fiscal_position=fiscal_position, flag=flag)
        if not ret.get('warning') and product:
            product_obj = self.pool.get('product.product')
            product_uom_obj = self.pool.get('product.uom')
            product_obj = product_obj.browse(cr, uid, product, context=context)
            uom2 = False
            if uom:
                uom2 = product_uom_obj.browse(cr, uid, uom)
                if product_obj.uom_id.category_id.id != uom2.category_id.id:
                    uom = False

            if (product_obj.type=='product') and product_obj.procure_method=='make_to_order':
                bom_id = self.pool.get('mrp.bom').search(cr, uid, [
                            ('product_id', '=', product_obj.id),
                            ('bom_id', '=', False),
                            ('type', '=', 'assembly')])
                if bom_id:
                    bom_id = bom_id[0]
                    bom_obj = self.pool.get('mrp.bom').browse(cr, uid, bom_id)
                if bom_id and (bom_obj.bom_stock_value  < qty * product_obj.uom_id.factor):
                        warning = {
                            'title': _('Not enough stock !'),
                            'message': _('You plan to move %.2f %s but you only have %.2f %s available !\nThe real stock is %.2f %s. (without reservations)') %
                                (qty, uom2 and uom2.name or product_obj.uom_id.name,
                                 max(0,bom_obj.bom_stock_value), product_obj.uom_id.name,
                                 max(0,product_obj.qty_available), product_obj.uom_id.name)
                        }     
                        ret['warning'] = warning
        return ret
sale_order_line()






# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4: