# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields,osv
from tools.translate import _

class res_partner_address(osv.osv):
    '''
        New localtion fields and zip field as a many2one
    '''
    _description ='Partner Addresses'
    _name = 'res.partner.address'
    _inherit='res.partner.address'
    _columns = {
                    'longitude':fields.char('Longitude', size=64,),
                    'latitude':fields.char('Latitude', size=64,),
                    'zip_id':fields.many2one("address.zip", "Zip"),
                    'zip': fields.char('ZIP', change_default=True, size=24),
                }




    def on_change_zip(self,cr,uid,id,zip, context={}):
        '''
            location details from new zip field (many2one)
        '''
        company_obj = self.pool.get('res.company').browse(cr,uid,uid,context=context)
        if not company_obj.lzipmatch:
            return {'value':{}}
        if not zip:
            return {'value':{
                      'zip' : ''
                         }}
        zip = self.pool.get('address.zip').browse(cr,uid,zip, context=context)
        return {'value':{
                      'zip' : zip.zipcode,
                      'longitude':zip.longitude,
                      'latitude':zip.latitude,
                       'city':zip.city,
                       'state_id':zip.state_id.id,
                                              }
                }


res_partner_address()



    # vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
