# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################


from osv import fields,osv
from xml.dom.minidom import Document
import httplib
import xml2dic
import base64


class stock_packages(osv.osv):

    def process_package(self,cr, uid, ids, context=None):
        return True

    _inherit = "stock.packages"
    _columns = {
            'shipment_digest': fields.text('ShipmentDigest'),
            'negotiated_rates': fields.float('NegotiatedRates'),
            'shipment_identific_no': fields.char('ShipmentIdentificationNumber', size=64, ),
            'tracking_no': fields.char('TrackingNumber', size=64, ),
            'logo':fields.binary('Label'),
            'ship_message':fields.text('Status Message'),
            'tracking_url':fields.char('Tracking URL', size=512, ),
            }
    _defaults = {'packge_no': False
                 }
    
    def onchange_weight(self, cr, uid, ids, line_ids, tot_order_weight, weight,context={}):
        '''
        Function to automatically fill package weight
        '''
        ret = {}
        if weight:
            ret['weight'] = weight
        else:
            used_weight = 0
            for line in line_ids:
                 if line and line[2] and line[2]['weight']:
                     used_weight += line[2]['weight']
            if used_weight < tot_order_weight:
                ret['weight'] = tot_order_weight - used_weight
        return {'value':ret}
    def onchange_packge_no(self, cr, uid, ids, line_ids,packge_no,context={}):
        '''
        Function to generate sequence on packages
        '''
        ret = {}
        if packge_no:
            ret['packge_no'] = packge_no
        else:
            for line in line_ids:
                 if line and line[2] and line[2]['packge_no'] and packge_no < line[2]['packge_no']:
                     packge_no=line[2]['packge_no']
            packge_no+=1
            ret['packge_no'] = packge_no
        return {'value':ret}
    def print_label(self, cr, uid, ids, context=None):
        if not ids: return []
        return {
            'type': 'ir.actions.report.xml',
            'report_name':'ship.label.print',
            'datas': {
                    'model':'stock.packages',
                    'id': ids and ids[0] or False,
                    'ids': ids and ids or [],
                    'report_type': 'pdf'
                },
            'nodestroy': True
            }

stock_packages()