# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################
from osv import fields,osv

class stock_picking(osv.osv):
    
    _inherit = "stock.picking"
    def write(self, cr, uid, ids, vals, context=None):
        '''
            Update the assigned picker of deliver products when changing the picker in delivery order
        '''    

        try:
            if 'assigned_picker' in vals:
                sale_ids = []
                if type(ids) == type([]):
                    for id in ids:
                        sale = self.pool.get('stock.picking').read(cr, uid, id, ['sale_id'])['sale_id']
                        if sale:
                            sale_ids.append(sale[0])
                    sale_ids = list(set(sale_ids))
                move_ids = self.pool.get('stock.move').search(cr,uid,[('picking_id.sale_id','in',sale_ids),('state','not in',['done','cancel'])])
                if move_ids:
                    self.pool.get('stock.move').write(cr,uid,move_ids,{'assigned_picker':vals['assigned_picker']})
        except:
            pass
        return super(stock_picking, self).write(cr, uid, ids, vals, context=context)
    _columns = {
        'assigned_picker':fields.many2one('res.users','Assigned Picker'),
        }

stock_picking()
class stock_move(osv.osv):
    '''
        Add assigned picker on deliver products
    '''    
    _inherit = "stock.move"
    
    _columns = {
        'assigned_picker':fields.many2one('res.users','Assigned Picker'),
        }

stock_move()


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

