# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

import pooler
from osv import fields, osv
from tools.translate import _
import tools


class assigned_picker(osv.osv_memory):
    _name = "stock.assigned.picker"
    _description = "Summary Report"
    _columns = {
                'name':fields.many2one('res.users','User'),
                'read_only':fields.boolean('Make Read only'),
    }
    def _get_default_name(self, cr, uid, context=None):
        return uid
    def _get_default(self, cr, uid, context=None):
        mod_data_ids = self.pool.get('ir.model.data').search(cr,uid,[('name','=','group_stock_manager'),('model','=','res.groups')])
        group_id = self.pool.get('ir.model.data').read(cr,uid,mod_data_ids,['res_id'])[0]['res_id']
        users = self.pool.get('res.groups').read(cr,uid,group_id,['users'])['users']
        return uid in users
    _defaults={'name':_get_default_name,
              'read_only':_get_default,
              }
    def print_report(self, cr, uid, ids, context=None):
        data = self.browse(cr, uid, ids[0], context=context)
        return {
        'type': 'ir.actions.report.xml',
        'report_name':"pick_list.report",
        'datas': {
                'model':'res.users',
                'id': data.name and data.name.id or False,
                'ids': data.name and [data.name.id] or [],
                'report_type': 'pdf',
            },
        'nodestroy': False,
        'context':context,
        }
assigned_picker()




# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:

