# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv
from tools.translate import _
import tools
from xml.dom.minidom import Document
import httplib
import base64
from urlparse import urlparse
import wizard
import pooler
import time

class replenish_model(osv.osv):


    _name = "replenish.model"
    _rec_name = 'replenish_move'
    _description='Amount of Products to be Replenished in Locations'
    _columns = {
                'replenish_move': fields.char('Replenish Move', size=64,),
                'product_name': fields.many2one('product.product','Product Name',),
                'reference': fields.char('Reference', size=64,),
                'primary_loc':fields.many2one('stock.location','Primary Location'),
                'replenish_loc':fields.many2one('stock.location','Replenish Loc'),
                'amt_to_move': fields.float('Amt to move'),
                'amt_left': fields.float('Amt left in Replenish loc'),
                'amt_moved': fields.float('Amt moved'),
                'date_moved':fields.datetime('Date'),
                'state':fields.selection([('draft', 'Draft'),('cancel', 'Cancel'),('done', 'Done')], 'State',),
              }
    _defaults={
            'replenish_move':lambda obj, cr, uid, context: obj.pool.get('ir.sequence').get(cr, uid, 'replenish.model'),
            }
replenish_model()


# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
