# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv
from tools.translate import _
from urlparse import urlparse
import wizard
import pooler
import time




class wizard_replenish(osv.osv_memory):
    _name = "replenish.wizard"
    _description = "replenish  wizard"


    def make_replenish_model(self, cr, uid, ids, context):
        id_list=[]
        if context and type(context) == type({}) and context.get('active_model') == 'product.product' and context.has_key('active_ids'):   #get the required product ids
            prod_ids=context['active_ids']
            repl_ids=pooler.get_pool(cr.dbname).get('replenish.model').search(cr,uid,[('product_name', 'in' ,prod_ids), ('state', '!=','done')]) #delelte previous replenish data the for selected products
            pooler.get_pool(cr.dbname).get('replenish.model').unlink(cr, uid, repl_ids)
        else:
            prod_ids=pooler.get_pool(cr.dbname).get('product.product').search(cr,uid,[])#get all Product ids
            repl_ids=pooler.get_pool(cr.dbname).get('replenish.model').search(cr,uid,[])#delelte previous replenish data the for selected products
            pooler.get_pool(cr.dbname).get('replenish.model').unlink(cr, uid, repl_ids)


        for prod_id in prod_ids:                                                    #for each product do
            vals={}                                                                #Initialize variables
            amt_needed=0
            multiple=0
            sum=0
            amt_remaining=0
            total_amt_to_move=-1

            product=pooler.get_pool(cr.dbname).get('product.product').browse(cr,uid,prod_id)
            vals['product_name']=product.id
            vals['state']='draft'
            if product.default_code:
                vals['reference']=product.default_code
            else:
                vals['reference']=''

            for multi_loc in product.multi_location_ids  :                                                 #for each multi location line do
                if not multi_loc.location_active:
                    continue

                if multi_loc.storage_type == 'primary' and multi_loc.location_active :                                  #check if the location is primary
                    vals['primary_loc']=multi_loc.location_name.id                        #if yes add to vals dictionary

                    if multi_loc.qty_available < multi_loc.min_level:                        #if real stock is less than min level
                           amt_needed=multi_loc.target_level-multi_loc.qty_available         #find out the amount that has to be refilled to the primary location
                           if  amt_needed > 0:                                                #if amount needed id > 0
                               try:
                                   multiple=amt_needed/multi_loc.qty_multiple
                               except:
                                   print "raise error qty_multiple shall not be zero"
                                   multiple=0
                               total_amt_to_move=multi_loc.qty_multiple * int(multiple)                    #find out the actual amount that can be moved
                               amt_remaining=total_amt_to_move

                           else:                                                                        #amount need is less than zero so break
                               break
                    else:
                        break
                    
            for multi_loc in product.multi_location_ids  :                                                 #for each multi location line do
                if not multi_loc.location_active:
                    continue

                if multi_loc.storage_type == 'primary' and multi_loc.location_active :                                  #check if the location is primary
                    vals['primary_loc']=multi_loc.location_name.id                        #if yes add to vals dictionary

                if multi_loc.storage_type != 'primary' and multi_loc.location_active and multi_loc.qty_available > 0 and amt_remaining > 0:
                    vals['replenish_loc']=multi_loc.location_name.id

                    if multi_loc.qty_available >= amt_remaining:
                        vals['amt_left']=multi_loc.qty_available-amt_remaining
                        vals['amt_to_move']=amt_remaining
                        amt_remaining=0
                    else:
                        vals['amt_left']=0
                        vals['amt_to_move']=multi_loc.qty_available
                        amt_remaining=amt_remaining-multi_loc.qty_available

                if not vals.has_key('replenish_loc') or not vals.has_key('primary_loc') or  vals['amt_to_move'] <=0 :  #if there is no replenish_loc/primary_loc/or amount to move continue with next multi location line
                           continue
                vals['date_moved']=time.strftime('%m-%d-%Y %H:%M:%S')
                id_list.append(pooler.get_pool(cr.dbname).get('replenish.model').create(cr,uid,vals))
                del vals['amt_left']
                del vals['amt_to_move']
                del vals['replenish_loc']
        id_list=list(set(id_list))
        return {
                'domain': [('id','in', id_list)],
                'name': _('Replenish Data'),
                'view_type': 'form',
                'view_mode': 'tree,form',
                'res_model': 'replenish.model',
                'views': False,
                'type': 'ir.actions.act_window',
                'target': 'current',
            }

wizard_replenish()




# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
