# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2011 NovaPoint Group LLC (<http://www.novapointgroup.com>)
#    Copyright (C) 2004-2010 OpenERP SA (<http://www.openerp.com>)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>
#
##############################################################################

from osv import fields, osv
from tools.translate import _
from urlparse import urlparse
import wizard
import pooler




class wizard_replenish_button(osv.osv_memory):


    def _get_product(self, cr, uid, context=None):
        if context.has_key('active_model') and context.has_key('active_id'):
            model_id = context['active_id']
            model_obj=pooler.get_pool(cr.dbname).get(context['active_model']).browse(cr,uid,model_id,context=None)
        return  model_obj.product_name.id


    def ok_action(self,cr,uid,ids,data,context=None):
        vals={}
        wizard_obj=pooler.get_pool(cr.dbname).get('wizard.replenish.button').browse(cr,uid,ids[0])
        model_obj=pooler.get_pool(cr.dbname).get(data['active_model']).browse(cr,uid,data['active_id'])

        if wizard_obj.qty > 0 and wizard_obj.qty <= model_obj.amt_to_move:
            vals['product_id']=model_obj.product_name.id
            vals['location_id']=model_obj.replenish_loc.id
            vals['location_dest_id']=model_obj.primary_loc.id
            vals['product_qty']=wizard_obj.qty
            vals['product_uom']=model_obj.product_name.uom_id.id
            vals['state'] = 'done'

            picking_id = self.pool.get('stock.picking').create(cr, uid, {
                            'origin': model_obj.replenish_move,
                            'type': 'internal',
                            'state': 'done',
                            'move_type': 'direct',
                        })
            vals['picking_id']=picking_id
            vals['name']=model_obj.replenish_move
            move_id = self.pool.get('stock.move').create(cr, uid,vals)
            #self.pool.get('stock.move').action_confirm(cr,uid,[move_id], context=context)
            #self.pool.get('stock.picking').action_done(cr, uid, [picking_id], context=context)
            model_obj.write({'amt_moved':wizard_obj.qty, 'state':'done'})

        if wizard_obj.remove_sec_loc:
            if model_obj.amt_left <= 0 :
                stock_loc_id=pooler.get_pool(cr.dbname).get('stock.multi.location').search(cr,uid,[('location_name', '=' ,model_obj.replenish_loc.id)])
                pooler.get_pool(cr.dbname).get('stock.multi.location').unlink(cr, uid, stock_loc_id)

        return {}

    def _get_left_qty(self, cr, uid, context=None):
        if context.has_key('active_model') and context.has_key('active_id'):
            model_id = context['active_id']
            model_obj=pooler.get_pool(cr.dbname).get(context['active_model']).browse(cr,uid,model_id,context=None)
            if model_obj.amt_left <=0:
                return True
            else:
               return False

    def _get_qty(self, cr, uid, context=None):
        if context.has_key('active_model') and context.has_key('active_id'):
            model_id = context['active_id']
            model_obj=pooler.get_pool(cr.dbname).get(context['active_model']).browse(cr,uid,model_id,context=None)
            return  model_obj.amt_to_move


    _name = "wizard.replenish.button"
    _rec_name = 'product_id'
    _columns = {
                'product_id':fields.many2one('product.product','Product'),
                'remove_sec_loc':fields.boolean('Remove The Secondory Location'),
                'qty':fields.integer('Amount to Replenish'),
                'real_lt_qty':fields.boolean('Real stock lt QTY'),

                }
    _defaults = {
             'product_id':_get_product,
             'qty':_get_qty,
             'real_lt_qty':_get_left_qty,
             'remove_sec_loc':True

            }
wizard_replenish_button()






# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
